/*
 * This file was automatically generated by oml2-scaffold
 * for generator version 1.0.0.
 * Please edit to suit your needs; the run() function should contain application code.
 */
#define _GNU_SOURCE  /* For NAN, M_PI */
#include <stdio.h>
#include <math.h>
#include <unistd.h>

#include <popt.h>
#include <oml2/omlc.h>

#define USE_OPTS /* Include command line parsing code*/
#include "generator_popt.h"

#define OML_FROM_MAIN /* Define storage for some global variables; #define this in only one file */
#include "generator_oml.h"

#include "config.h"

/* Do application-specific work here */
void
run(opts_t* opts, oml_mps_t* oml_mps)
{
  double angle = 0;
  double delta = opts->frequency * opts->sample_interval * 2 * M_PI;
  unsigned long sleep = (unsigned long)(opts->sample_interval * 1E6);

  printf("%f, %f, %ld\n", M_PI, delta, sleep);

  int i = opts->samples;
  unsigned int count = 1;
  for (; i != 0; i--, count++) {
    double value = opts->amplitude * sin(angle);
    char label[64];
    sprintf(label, "sample-%d", count);

    if(oml_inject_d_lin(oml_mps->d_lin, label, count) != 0) {
      logwarn("Failed to inject data into MP 'd_lin'\n");
    }

    if(oml_inject_d_sin(oml_mps->d_sin, label, angle, value) != 0) {
      logwarn("Failed to inject data into MP 'd_sin'\n");
    }

    printf("%s %d | %f %f\n", label, count, angle, value);

    angle = fmodf(angle + delta, 2 * M_PI);
    usleep(sleep);
  }
}

int
main(int argc, const char *argv[])
{
  int c, ret;

  if((ret = omlc_init("generator", &argc, argv, NULL)) < 0) {
    logerror("Could not initialise OML\n");
    return -1;
  }

  /* Parse command line arguments */
  poptContext optCon = poptGetContext(NULL, argc, argv, options, 0); /* options is defined in generator_popt.h */
  while ((c = poptGetNextOpt(optCon)) > 0) {}

  /* Initialise measurement points, only if OML is not disabled */
  oml_register_mps(); /* Defined in generator_oml.h */
  if(ret == 0 && omlc_start()) {
    logerror("Could not start OML\n");
    return -1;
  }

  run(g_opts, g_oml_mps_generator); /* Do some work and injections, see above */

  omlc_close();

  return 0;
}

/*
 Local Variables:
 mode: C
 tab-width: 2
 indent-tabs-mode: nil
 End:
 vim: sw=2:sts=2:expandtab
*/
